<?php  if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Subdomainmodel extends CI_Model {

    function __construct()
    {
        parent::__construct();
        
        $this->load->database();
        $this->load->library('session');
        $this->load->library('ion_auth');
        
        $this->load->config('subdomain_config');
        
    }
    
    
    /*
	    
	    retrieves the configuration from the DB
	    
    */
    
    public function getConfig() {
	    
    	$restult = array(array(
    		'config_id' => 1,
    		'config_name' => 'subdomain',
            'config_value' => $this->session->userdata('subdomain'),
            'config_default' => '',
            'config_description' => $this->lang->line('subdomains_settings_subdomain_description'),
            'config_required'=> 1));
	    
	    
	    return $restult;
	    
    }
    
    
    
    /*
	    
	    updates the configuration settings
	    
    */
    
    public function updateConfig($configData) {
	    
    	$ret = array();
    	
    	$subdomainName = strtolower($configData['subdomain']);
    	
    	//Check if more than 20 characters.
        if(strlen($subdomainName)>20){
			$ret['message'] = $this->lang->line('subdomains_error_size');
    		$ret['ret'] = 0;
    		return $ret;
    	}elseif(!preg_match('/[A-Za-z0-9]/', $subdomainName)){
    		$ret['message'] = $this->lang->line('subdomains_error_name');
    		$ret['ret'] = 0;
    		return $ret;
        }
    	
    	$query = $this->db->from('users')->where('subdomain', $subdomainName)->get();
    	    	
    	if( $query->num_rows() > 0 ) {
    		$ret['message'] = $this->lang->line('subdomains_error_unavailable');
    		$ret['ret'] = 0;
    		return $ret;
    	}
    	
    	
    	
	    //subdomain
	    $data = array(
        	'subdomain' => $subdomainName
        );
        

        $this->db->where('id', $this->session->userdata('user_id'));
        $this->db->update('users', $data);
        
        try{
        	$this->session->set_userdata(array('subdomain'=>$subdomainName));
        	$subdomain = $this->create_subdomain($subdomainName);
        	
        	$ret['ret'] = 1;
        	$ret['message'] = '';
        }
    	catch (Exception $e){
    		$ret['message'] = $e->getMessage();
    		$ret['ret'] = 0;
		}
		
		return $ret;
    }
    
    private function create_subdomain($subDomain) {
    	$subDomain = strtolower($subDomain);
		//print($this->config->item('rootDomain', 'subdomain'));
		//exit;
	//	echo $subDomain;
	//	die();
		//$buildRequest = "/frontend/x3/subdomain/doadddomain.html?rootdomain=" . $rootDomain . "&domain=" . $subDomain;
		$buildRequest = "/frontend/x3/subdomain/doadddomain.html?rootdomain=" . $this->config->item('rootDomain', 'subdomain') . "&domain=" . $subDomain . "&dir=" . $this->config->item('primedir', 'subdomain') . '/' . $subDomain;
		
		//print($buildRequest);
		//exit;
		
		$openSocket = fsockopen('localhost', 2082);
		if (!$openSocket) {
			return "Socket error";
			exit();
		}
		
		//var_dump($openSocket);
		
		$authString = $this->config->item('cPanelUser', 'subdomain') . ":" . $this->config->item('cPanelPass', 'subdomain');
		$authPass = base64_encode($authString);
		$buildHeaders = "GET " . $buildRequest . "\r\n";
		$buildHeaders .= "HTTP/1.0\r\n";
		$buildHeaders .= "Host:localhost\r\n";
		$buildHeaders .= "Authorization: Basic " . $authPass . "\r\n";
		$buildHeaders .= "\r\n";

		$ret = fputs($openSocket, $buildHeaders);
		
		//var_dump($ret);
		$ret = '';
		
		while (!feof($openSocket)) {
			$ret .= fgets($openSocket, 128);
		}
		fclose($openSocket);
		
		//print($ret);
		//exit;

		$newDomain = "http://" . $subDomain . "." . $this->config->item('rootDomain', 'subdomain') . "/";
		//  return "Created subdomain $newDomain";

		return $newDomain;

	}

	//This is for killswitch

	public function delete_subdomain($subDomainurl) {
		//$removeHTTP = str_replace('http://', '', $subDomainurl);
		//$removeHTTPs = str_replace('https://', '', $removeHTTP);
		//$domain_arr = explode('.', $removeHTTPs);
		//$subDomain = $domain_arr[0];
		$subDomain = $subDomainurl;
		$buildRequest = "/frontend/x3/subdomain/dodeldomain.html?rootdomain=" . $this->config->item('rootDomain', 'subdomain') ."&domain=".$subDomain;
		
		$openSocket = fsockopen('localhost', 2082);
		//$openSocket = fsockopen($this->config->item('ipDomain', 'subdomain'), 2082);
		if (!$openSocket) {
			return "Socket error";
			exit();
		}

		$authString = $this->config->item('cPanelUser', 'subdomain') . ":" . $this->config->item('cPanelPass', 'subdomain');
		$authPass = base64_encode($authString);
		$buildHeaders = "GET " . $buildRequest . "\r\n";
		$buildHeaders .= "HTTP/1.0\r\n";
		$buildHeaders .= "Host:localhost\r\n";
		$buildHeaders .= "Authorization: Basic " . $authPass . "\r\n";
		$buildHeaders .= "\r\n";

		fputs($openSocket, $buildHeaders);
		
		$ret = '';
		
		while (!feof($openSocket)) {
			$ret .= fgets($openSocket, 128);
		}
		fclose($openSocket);

		//Note:  this may not be required as it is used to remove the directory.
		//Directory is not being created. Hence need not be deleted.

		//$passToShell = "rm -rf /home/" . self::cPanelUser . "/".self::primedir . $subDomain;
		//system($passToShell);
		
		return TRUE;
	}
    
}